/* titel: copy.c, Kopierprogramm auf low level Basis */
/* titel: error(), Beispiel fuer Funktion mit variabler Argumentzahl */
/* K&R 2, chpt. 8.3, p. 172ff. */


#include <stdio.h>
#include <fcntl.h>

#define BUFSIZE 1024
#define PERMS 0644       /* Lese-Schreib-Berechtigung fuer Besitzer, 
			    Lese-Berechtigung fuer Gruppe, Welt */
char* progname = "copy";

void error(char *, ...);

main(int argc, char *argv[]) {
  int f1, f2, n;
  char buf[BUFSIZE];
  
  if (argc != 3)
    error("Gebrauch: %s quelle ziel", progname);
  if ((f1 = open(argv[1], O_RDONLY, 0)) == -1 )
    error("%s: %s kann nicht geoeffnet werden",progname, argv[1]);
  if ((f2 = creat(argv[2], PERMS)) == -1)
    error("%s: %s kann nicht im Modus %03o geoeffnet werden",
	  progname, argv[2], PERMS);
  while ((n = read(f1, buf, BUFSIZE)) > 0)
    if (write(f2, buf, n) != n)
      error("%s: Schreiberror in Datei %s", argv[2]);
  return 0;
}

#include <stdarg.h> /* Definiert die Macros va_list, va_start(), va_end() */

void error(char *fmt, ...) {
  va_list args;
  va_start(args, fmt);
  fprintf(stderr, "Fehler: ");
  vfprintf(stderr, fmt, args);
  fprintf(stderr,"\n");
  va_end(args);
  exit(1);
}
