/* titel: inttest.c, zeigt die Verwendung von setjmp, longjmp und
	einigen Interupts */

#include <signal.h>
#include <setjmp.h>
#include <stdio.h>
#include <math.h>
#include <string.h>

/* Auf  manchen Rechnern gibt es die Funktion raise() nicht. 
Dann kann man die folgende Definition verwenden:

#define raise(A) kill(getpid(),(A))

*/


jmp_buf start;	         /* Hier wird von setjmp() der Stack gesichert */

main(){
    int c; double d;
    int trace(), fpe(), seg();
                         /* Interrupt-Handler:  */
    void trapcatch(), fpecatch(), segvcatch(), buscatch();
   
    c = setjmp(start); 	/* Stack wird gesichert fuer spaeteren Ruecksprung */
			/* Die Handler enthalten den longjmp()-Befehl	*/
    signal(SIGTRAP, trapcatch );  /* Installation der Interrupt-Handler */
    signal(SIGFPE,  fpecatch );
    signal(SIGSEGV, segvcatch );
    signal(SIGBUS,  buscatch );
    printf("\n...Signal initialisiert... setjmp(start) = %d \n", c);

    while(1) {
	char answ;
	printf("\n\
              Welcher Interrupt?\n\n\
               (t) Trace trap              		(SIGTRAP)\n\
	       (f) Floating point exception 		(SIGFPE)\n\
	       (s) Segmentation fault or bus error      (SIGSEGV/SIGBUS)\n\
                : ");
	answ = getchar(); getchar();
	switch ( answ) {
	  case 't': trace(); break;
	  case 'f': fpe();   break;
	  case 's': seg();   break;
	  default: break;
	}
    }
}
trace() {
    int d, q;
    printf("Trace trap Interrupt provoziert durch Integer-Null-Division:\n");
    while (1) {
	printf("24/? ");
	scanf("%d", &d); getchar();
	q = 24 / d;
	printf("24/%d = %d\n",d,q);
    }
}
void trapcatch() {
    fprintf(stderr,"Integer-Division durch 0 ???\n");
    longjmp(start,1);
}
/* Der fpe-Interrupt kann direkt auf neueren Prozessoren nicht mehr 
   abgefangen werden, da "infinity" und "NaN" (Not a Number) als
   "Fliesskomma"-Zahlen, daher benutzen wir die Funktion raise, die
   ein Interrupt-Signal provoziert.  */
int fpe() {
    double d, q;
    printf("Floating point exception Interrupt\n\
            provoziert durch Null-Division:\n");
    while (1) {
	printf("24.0/? ");
	scanf("%lf", &d); getchar();
	q =  24.0 / d;
	printf("Kein Interrupt: 24/%lf = %lf \n",d,q);
	if ( q == HUGE_VAL) { /* Infinity wird durch HUGE_VAL in  math.h definiert */
/* Sollte es die Funktion raise() nicht geben, koennen Sie die 
   eingangs erwaehnte #define-Anweisung verwenden. */

	  printf("raise...\n");
	  raise(SIGFPE);
	}
    }
}
void fpecatch() {
    fprintf(stderr,"Division durch 0 ???\n");
    longjmp(start,2);
}
int seg() {
    char x, *c;
    char ans[40];
    int i;
    printf("\
           Segmentation fault oder Bus error Interrupt\n\
           durch Schreibversuch auf unzulaessige Adresse:\n
           (gueltige Adresse: %d)\n", &x);
    while(1) {
	printf("(char *)Adresseneingabe: c = [%d+Eingabe, 0 ist ok] ", &x);
	gets(ans);
	if (strlen(ans) == 0)
	    c = &x;
	else {
	    sscanf(ans,"%d", &i);
	    c = &x + i;
	}
	*c = 'a';
	printf("kein Interrupt: *c = %c\n", *c);
    }
}
void segvcatch() {
    fprintf(stderr,"\
            Segmentation Fault: Schreibversuch auf unerlaubte Adresse!\n");
    longjmp(start,3);
}
void buscatch() {
    fprintf(stderr,"\
            Bus Error: Schreibversuch auf unerlaubte Adresse!\n");
    longjmp(start,4);
}



