/* Die folgenden Funktionen sind im ANSI-C-Format geschrieben! 
   Zur \Ubersetzung ist ein ANSI-f\ahiger Compiler n\otig, z. B.
   der GNU-C-Compiler gcc auf math5, math6.
   Aufruf mit 
                    gcc dcl.c
   usw. (Gleiche Optionen wie bei cc)                             
   F\ur andere Compiler sind die Funktionsdeklarationen umzuschreiben.    
   \Ubungsaufgabe!  
*/
/* titel: dcl.c     parse a C declaration into words   K&R 2nd, p. 123     */
/* Typische Ein- und Ausgaben von dcl:
   m5:% dcl
   int *funct[]()
   funct:  array[] of function returning pointer to int
   double (*FUNCT[])()
   FUNCT:  array[] of pointer to function returning double
   char *argv[]
   argv:  array[] of pointer to char
   char **argv
   argv:  pointer to pointer to char
*/

#include "parse.h"

extern int gettoken(void);

main () {			/* convert declaration to words */
    while (gettoken () != EOF) {
	strcpy (datatype, token);
	out[0] = '\0';
	dcl ();			/* parse rest of line */
	if (tokentype != '\n')
	    printf ("syntax error\n");
	printf ("%s: %s %s\n", name, out, datatype);
    }
    return 0;
}
void dcl (void) {		/*  dcl: parse a declarator */
    int     ns;
    for (ns = 0; gettoken () == '*';)	/* count *'s */
	ns++;
    dirdcl ();
    while (ns-- > 0)
	strcat (out, " pointer to");
}
void dirdcl (void) {		/* dirdcl: parse a direct declarator */
    int     type;
    if (tokentype == '(') {	/* ( dcl ) */
	dcl ();
	if (tokentype != ')')
	    printf ("error: missing )\n");
    }
    else
	if (tokentype == NAME)
	    strcpy (name, token);
	else
	    printf ("error: expected name or (dcl)\n");
    while ((type = gettoken ()) == PARENS || type == BRACKETS)
	if (type == PARENS)
	    strcat (out, " function returning");
	else {
	    strcat (out, " array");
	    strcat (out, token);
	    strcat (out, " of");
	}
}
