/*titel:undcl.c, konvertiert sprachliche Beschreibung in Deklaration  
         K&R 2nd, p. 126. 

Typische Ein- und Ausgaben sind etwa folgende:
(Die in Klammern angegebene Zeilen sind die umgangssprachlichen 
Formulierungen der jeweils folgenden undcl-Eingabezeile.)
     m5:% undcl
    (funct ist Array von Pointern von Funktionen auf double)
    funct [] * () double
    double (*funct[])()
    (wurzel ist Funktion auf double)
    wurzel () double
    double wurzel()
    (argv ist Array von Pointern auf char)
    argv [] * char
    char (*argv[])
    (argv ist Pointer auf Pointer auf char)
    argv * * char
    char (*(*argv))
    (FCT ist Array von Funktionen auf Pointer auf long)
    FCT [] () * long
    long (*FCT[]())
*/

#include "parse.h"

main () {
    int     type;
    char    temp[MAXTOKEN];
    while (gettoken () != EOF) {
	strcpy (out, token);
	while ((type = gettoken ()) != '\n')
	    if (type == PARENS || type == BRACKETS)
		strcat (out, token);
	    else
		if (type == '*') {
		    sprintf (temp, "(*%s)", out);
		    strcpy (out, temp);
		}
		else
		    if (type == NAME) {
			sprintf (temp, "%s %s", token, out);
			strcpy (out, temp);
		    }
		    else
			printf ("invalid input at %s\n", token);
	printf ("%s\n", out);
    }
    return 0;
}

