/* titel: calc.c, UPN-Taschenrechner nach K&R2, p.74ff.    */

#include <signal.h>
#include "Lcalc.h"

#define C 4
#define R 4

void posprint(int i, int j, char *s) {
  mvcur(0,0,i+R,j+C); printf(s); fflush(stdout); 
}

main() {
  int     type;
  char    s[MAXOP];
  double  op2,
  atof(), pop(), push();
  void intcatch();
  signal(SIGINT, intcatch);
  loadstack();
  initscr();
  refresh();
  posprint(-1,6,"\nTaste ? liefert Information\n");
  printstack();
  while ((type = getop (s, MAXOP)) != EOF) {
    switch (type) {
    case NUMBER: push (atof (s)); break;
    case '+': push (pop() + pop()); break;
    case '*': push (pop() * pop()); break;
    case '-': op2 = pop(); push (pop() - op2); break;
    case '/': op2 = pop();
      if (op2 != 0.0)
	push (pop() / op2);
      else
	printf ("Divisor 0\n");
	break;
    case 'l': endwin(); system("clear"); initscr(); refresh(); 
        posprint(-1,6,"\nTaste ? liefert Information\n"); break;
    case 'c': clear_stack(); break;
    case 'n': negate(); break;
    case 'i': invers(); break;
    case 'x': exchange(); break;
    case 'p': pop(); break;
    case 'd': doppel(); break;
    case '?': info(); break;
    case 'q': goto leave;
    case TOOBIG: printf ("%.40s ... ist zu lang\n", s); break;
    default: printf ("unbekanntes Kommando: %c\n", type); break;
    }
    printstack();
  }
 leave: 
  writestack();
  endwin();
  system("clear");
}
void intcatch() {
  writestack();
  endwin();
  system("clear");
  exit (0);
}
void info(void) {
  system("clear");
    printf("\n
\n
\
             Liste der installierten Kommandos:\n
\n
\
             ( sti bezeichnet das i-te Stackregister )\n
\
             +         st1 <--  st1 + st2\n
\
             -         st1 <--  st2 - st1\n
\
             *         st1 <--  st1 * st2\n
\
             /         st1 <--  st2 / st1\n
\
             n         st1 <--  -st1\n
\
             i         st1 <--  invers(st1)\n
\
             c         loescht Stack \n
\
             l         loescht Bildschirm\n
\
             di        st1 <--  sti  (0 < i < 10)\n
\
	     xi        st1 <--> sti  (0 < i < 10)\n
\
	     p         loescht st1 \n
\
	     ? loescht Bildschirm und listet installierte Kommandos \n
\
	     q beendet und sichert Stack nach ~/bin/calc.dat\n
\
	     <Ctrl >c beendet das Programm, ohne zu sichern !\n
\
	     Eingabesyntax ist umgekehrte polnische Notation.\n
\
	     Beispiel : Eingabe 3.2 2.1 + 2 * = <return > ergibt 10.6\n
\
	     Leerzeichen trennt Zahlen - sonst irrelevant.\n
 
             Weiter mit Eingabe von Taste \"w\" .\n
");
    while (my_getch() != 'w')
      ;
    endwin(); system("clear"); initscr(); refresh(); 
        posprint(-1,6,"\n
Taste ? liefert Information\n
");
}

/* -------------------------- Ende von calc.c -------------------------- */
